class Main {
    static ThreadLocal thrloc = new ThreadLocal() {
        public Object initialValue() {
            return new StringBuffer("Buffer ");
        }
    };

    Main() {
        System.out.println(thrloc.get());                // 1: "Buffer"
        ((StringBuffer)thrloc.get()).append("1");
        System.out.println(thrloc.get());                // 2: "Buffer 1"

        Thread t = new MyThread();
        t.start();
        try {
            t.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        System.out.println(thrloc.get());                // 5: "Buffer 1"
    }

    public static void main(String[] args) {
        new Main();
    }
}

class MyThread extends Thread {
    public void run() {
        System.out.println(Main.thrloc.get());           // 3: "Buffer"
        ((StringBuffer)Main.thrloc.get()).append("2");
        System.out.println(Main.thrloc.get());           // 4: "Buffer 2"
    }
}
