import java.net.*;
import java.io.*;
import java.util.Date;

class EchoServer extends Thread {
    private DatagramSocket sock = null;
    EchoServer(int port) {
        try {
            sock = new DatagramSocket(port);
        } catch (SocketException e) {
            e.printStackTrace();
        }
    }
    public void run() {
        if (sock == null)
            return;

        byte[] inbuf = new byte[2024];
        DatagramPacket request = new DatagramPacket(inbuf, inbuf.length);
        try {
            while (true) {
                sock.receive(request);
                sock.send(request); // just return what was sent
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}

class Main {
    static int echo_port = 1257;

public static void echo(String msg, InetAddress dst, int port) {
    byte[] inbuf = new byte[1024];  // default size
    byte[] outbuf = msg.getBytes();

    try {
//
        DatagramSocket client = new DatagramSocket();
        DatagramPacket request = new DatagramPacket(outbuf, outbuf.length, 
            dst, port);
        DatagramPacket reply = new DatagramPacket(inbuf, inbuf.length);

        System.out.println("original receive buffer size: " +
            client.getReceiveBufferSize());
        client.setReceiveBufferSize(1024);
        System.out.println("using receive buffer size: " +
            client.getReceiveBufferSize());
        System.out.println("attempting to send: " + request.getLength() + " bytes");

        client.send(request);
        client.receive(reply);

        System.out.println("read: " + reply.getLength() + " bytes");

        client.close();
//
    } catch (SocketException e) {
        e.printStackTrace();
    } catch (IOException e) {
        e.printStackTrace();
    }
}
// END main2 

    public static void main(String[] args) {
        // start server
        EchoServer srv = new EchoServer(echo_port);
        srv.setDaemon(true);
        srv.start();
        StringBuffer buf = new StringBuffer(2000);
        for (int i = 0; i < 100; i ++) {
            buf.append(new Date());
        }
        try {
            InetAddress dst = InetAddress.getLocalHost();

            echo(buf.toString(), dst, echo_port);

        } catch (UnknownHostException e) {
            System.err.println("Host not found: " + e);
        }
    }
}
