import java.net.*;
import java.util.*;

class Main {
    public static void main(String[] args) {
        // Create a map with a few entries.
        Map m = new HashMap();
        m.put("c|net", "www.cnet.com");
        m.put("dst(p, q)", "sqrt((q.x-p.x)^2+(q.y-p.y)^2)");

        // Encode the entries in the map.
        String data = encode(m);
        System.out.println(data);
            // c%7Cnet=www.cnet.com&dst%28p%2C+q%29=sqrt%28%28
            // q.x-p.x%29%5E2%2B%28q.y-p.y%29%5E2%29

        // Decode the x-www-form-urlencoded string into a map.
        try {
            m = decode(data);
            System.out.println(m);
                // {c|net=www.cnet.com, 
                // dst(p, q)=sqrt((q.x-p.x)^2+(q.y-p.y)^2)}
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    // Returns x-www-form-urlencoded string of all the entries
    // in the map m.
    public static String encode(Map m) {
        int count = 0;
        StringBuffer buf = new StringBuffer();
        for (Iterator it=m.keySet().iterator(); it.hasNext(); count++) {
            String key = (String)it.next();

            if (count > 0) {
                buf.append('&');
            }
            buf.append(URLEncoder.encode(key)+"="+
                URLEncoder.encode((String)m.get(key)));
        }
        return new String(buf);
    }

    // Decodes the x-www-form-urlencoded string s and
    // returns a map containing all the encoded entries.
    public static Map decode(String s) throws IllegalArgumentException {
        Map m = new HashMap();
        try {
            StringTokenizer st = new StringTokenizer(s, "&");
    
            while (st.hasMoreElements()) {
                s = (String)st.nextElement();
                String key = URLDecoder.decode(s.substring(0, s.indexOf('=')));
                String value = URLDecoder.decode(s.substring(s.indexOf('=')+1));
                m.put(key, value);
            }
        } catch (Exception e) {
            throw new IllegalArgumentException();
        }
        return m;
    }
}
