import java.text.CollationElementIterator;
import java.text.Collator;
import java.text.RuleBasedCollator;
import java.util.Locale;

public class Main {
    public static void main(String[] args) {
        Locale loc = Locale.GERMAN;
        int element;

        // Set up string to iterate over.
        String str = "b";
        System.out.println("String: " + str + "\n");

        // Create an instance of a subclass of collator.
        Collator collator = Collator.getInstance(loc);

        if (collator instanceof RuleBasedCollator) {
            // Cast to the subclass.
            RuleBasedCollator rbc = (RuleBasedCollator)collator;

            // Get the first collation key of the string.
            CollationElementIterator cei = 
                rbc.getCollationElementIterator(str);

            element = cei.next();

            // Get the decomposed 'a'
            System.out.println( Integer.toHexString(element) );   // 52000
            System.out.println( cei.getOffset() );                // 1

            element = cei.next();

            // Get the decomposed accent for the 'a'
            System.out.println( Integer.toHexString(element) );   // 1c00
            System.out.println( cei.getOffset() );                // 1

            element = cei.next();

            // Get the character 'b'
            System.out.println( Integer.toHexString(element) );   // 53000
            System.out.println( cei.getOffset() );                // 2
        }
    }
}
