import java.text.CollationElementIterator;
import java.text.RuleBasedCollator;
import java.text.Collator;
import java.util.Locale;

public class Main {
    public static void main(String[] args) {
        Locale loc = Locale.FRENCH;

        String str = "abcABCADE";
        String pat = "A";

        System.out.println("String:  " + str);
        System.out.println("Pattern: " + pat + "\n");
        
        // Create an instance of a subclass of collator.
        Collator collator = Collator.getInstance(loc);

        boolean match;
        int patElement, strElement;

        if (collator instanceof RuleBasedCollator) {
            // Cast to the subclass.
            RuleBasedCollator rbc = (RuleBasedCollator)collator;

            CollationElementIterator strIter =
                      rbc.getCollationElementIterator(str);
        
            CollationElementIterator patIter =
                      rbc.getCollationElementIterator(pat);
            
            int END_OF_STRING = CollationElementIterator.NULLORDER;
            System.out.println("Searching... ");

            if (str.length() < pat.length()) {
               return;
	    }

            // Step through the string.
            for (int i = 0; i <= (str.length() - pat.length()); i++) {
                // Print diagnostic.
                System.out.println(str.substring(i, i + pat.length()));

                // See if the pattern's collation elements match 
                // the ones at this offset in the string.
                patIter.reset();
                strIter.setOffset(i);
            
                match = true;
                while (((patElement = patIter.next()) != END_OF_STRING)) {
                    strElement = strIter.next();
                    if (patElement != strElement) {
                        match = false;
                        break;
                    }
                }             
                if (match) {
                    System.out.println(
                       "Found a match " + pat + " at offset: " + i);
                }
            }
        }
    }
}
