import java.util.PropertyPermission;
import java.security.PermissionCollection;

public class Main {
    public static void main(String[] args) {
//
        PropertyPermission[] p = new PropertyPermission[3];

        // Allow entire java. hierarchy to be read
        p[0] = new PropertyPermission("java.*", "read");

        // Allow update to java.vendor.* hierarchy
        p[1] = new PropertyPermission("java.vendor.*", "write");

        // Allow read/update to os.version
        p[2] = new PropertyPermission("os.version", "read, write");

        PermissionCollection col = p[0].newPermissionCollection();
        for (int i = 0; i < p.length; i++) {
            col.add(p[i]);
        }

        // OK to read/write java.vendor.url?
        System.out.println(col.implies(
            new PropertyPermission("java.vendor.url", "read, write"))); 
                                                             // true

        // OK to read user.dir?
        System.out.println(col.implies(
            new PropertyPermission("user.dir", "read")));    // false

        // OK to write java.vendor ?
        System.out.println(col.implies(
            new PropertyPermission("java.vendor", "write")));
                        // false; java.vendor.* doesn't include java.vendor
//
    }
}


    
