import java.util.*;

class Main {
    public static void main(String[] args) {
//
        // This set's iterators return the elements in order.
        Set set = new TreeSet(Arrays.asList(new String[]{"e", "a", "d", "c", "b"}));
        for (Iterator it=set.iterator(); it.hasNext(); ) {
            System.out.print( it.next()+" " );
        }
        System.out.println();               // a b c d e 

        // This set's iterators return the elements in no particular order.
        set = new HashSet(Arrays.asList(new String[]{"e", "a", "d", "c", "b"}));
        for (Iterator it=set.iterator(); it.hasNext(); ) {
            System.out.print( it.next()+" " );
        } 
        System.out.println();               // e d b c a

        // Attempt to modify the set while an iterator is being used.
        Iterator  it = set.iterator();
        set.add("pig");
        //it.next();                        // ConcurrentModificationException

        // Create a set whose size cannot be changed.
        it = Collections.singleton("dog").iterator();
       it.next();
        it.remove();                        // UnsupportedOperationException
//
    }
}
