import java.util.*;

class Main {
    public static void main(String[] args) {
//
        Set set = new HashSet(Arrays.asList(new String[]{"dog", "cat"}));
        Set set2 = new HashSet(Arrays.asList(new String[]{"cat", "pig"}));

        // This creates a set made up of elements that the two sets do not have in common.
        Set common = new HashSet(set);
        common.retainAll(set2);
        System.out.println( common );               // [cat]
        Set notCommon = new HashSet(set);
        notCommon.addAll(set2);
        notCommon.removeAll(common);
        System.out.println( notCommon );         // [dog, pig]

        System.out.println( set.retainAll(Collections.singleton("dog")));
                                                                    // true
        System.out.println( set );                       // [dog]

        // This is an expensive way to clear the set.
        set.retainAll(Collections.EMPTY_SET);
        System.out.println( set );               // []

        set = Collections.singleton("dog");
        // The size of this set cannot be changed.
        set.retainAll(Collections.EMPTY_SET);   // UnsupportedOperationException
//
    }
}
