import java.util.*;

class Main {
    public static void main(String[] args) {
        HashSet set = new HashSet(Arrays.asList(new String[]{"dog", null}));

        Object[] objs = set.toArray();
        print(objs);                         // [dog, null]

        // Since we passed in a string array, we can cast
        // the result to a string array.
        String[] strings = (String[])set.toArray(new String[0]);
        print(strings);                      // [dog, null]

        // Try adding something other than a string to the set.
        set.add(new Integer(0));

        print( set.toArray() );              // [dog, 0, null]

        // The Integer object can not be stored in the string array.
        print( set.toArray(new String[0]) ); // ArrayStoreException
    }

    static void print(Object[] arr) {
        System.out.println(Arrays.asList(arr));
    }
}
