import java.util.*;
import java.util.jar.*;
import java.util.zip.*;

class Main {
    public static void main(String[] args) {
        if (args.length < 1) {
            System.err.println("Usage: java Main <jar-file>");
            System.exit(1);
        }

	try {
	    JarFile jf = new JarFile(args[0], true);

            // Print the contents of the manifest.
	    printManifest(jf.getManifest());

            // List all the entries in the jar file.
            for (Enumeration e=jf.entries(); e.hasMoreElements(); ) {
                JarEntry je = (JarEntry)e.nextElement();
	        System.out.println(je.getName()+": "+je.getSize()+" bytes");
            }
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    static void printManifest(Manifest man) {
	System.out.println("---------- Main Attributes");
	printAttributes(man.getMainAttributes());
	for (Iterator it=man.getEntries().keySet().iterator(); it.hasNext(); ) {
            String ename = (String)it.next();
            System.out.println("---------- " + ename);
	    printAttributes(man.getAttributes(ename));
	}
	System.out.println();
    }

    static void printAttributes(Attributes attr) {
        for (Iterator it=attr.keySet().iterator(); it.hasNext(); ) {
            Object key = it.next();
            System.out.println(key+": "+attr.get(key));
        }
    }
}
