import java.io.*;
import java.util.*;
import java.util.jar.*;

class Main {
    public static void main(String[] args) {
        Manifest man = new Manifest();
        man.getMainAttributes().put(Attributes.Name.MANIFEST_VERSION, "1.0");

        Attributes attr = new Attributes();
        attr.put(new Attributes.Name("Desc"), "Example for write() method");
        attr.put(new Attributes.Name("Date"), "10/11/98");
        man.getEntries().put("Main.java", attr);

        try {
            man.read(new FileInputStream("manifest.txt"));
        } catch (IOException e) {
            e.printStackTrace();
        }

        printManifest(man);
    }

    static void printManifest(Manifest man) {
        System.out.println("---------- Main Attributes");
        printAttributes(man.getMainAttributes());
        for (Iterator it=man.getEntries().keySet().iterator(); it.hasNext(); ) 
        {
            Object key = it.next();
            System.out.println("---------- " + key);
            printAttributes((Attributes)man.getEntries().get(key));
        }
    }

    static void printAttributes(Attributes attr) {
        for (Iterator it=attr.keySet().iterator(); it.hasNext(); ) {
            Object key = it.next();
            System.out.println(key + ": " + attr.get(key));
        }
    }
}
